#!/bin/bash
#SBATCH --job-name=testGPU
#SBATCH -o out
#SBATCH -e err
#SBATCH --time=01:00:00
#SBATCH --exclusive
##SBATCH nombre de noeuds requis
#SBATCH -N 1
##SBATCH nombre de coeurs par noeud
#SBATCH --tasks-per-node 24
#sbatch --gres=gpu:4 -constraint="Nvidia,K40-M"
#SBATCH -p sirocco
## modules requis
module purge
module add compiler/gcc/4.8.4
module add mpi/openmpi/gcc/1.8.5-tm
module add hardware/hwloc/1.11.0
module add intel/mkl/64/11.2/2015.3.187
module add compiler/cuda/6.5/nsight/6.5.14

## chemins vers starpu
export PKG_CONFIG_PATH=/home/terraz/starpu-1.1/install/lib/pkgconfig:$PKG_CONFIG_PATH
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/terraz/starpu-1.1/install/lib
export STARPU_SCHED=ws

## lancement executable
time mpirun -np 1 /home/terraz/ricarGPU/src/example/bin/simple -mm /projets/pastix/matrices.TT/mat_bloc2d_360x1000.mm -t 19 -iparm IPARM_STARPU API_YES -iparm IPARM_CUDA_NBR 4 -iparm IPARM_GPU_CRITERIUM 2 -v 4 > testGPU.res

