#cython: embedsignature=True

__all__ = ['MURGE']

# cython imports
from libc.stdlib cimport malloc, free
from libc.stdint cimport *
from posix.fcntl cimport O_RDONLY, O_WRONLY

from cpython cimport PyErr_SetFromErrno
from cpython.string cimport PyString_GET_SIZE, PyString_Check, PyString_AS_STRING

# python imports
import os
import numpy as np
cimport numpy as np
from collections import namedtuple
cimport cython
from mpi4py import MPI
# changed after 1.3
from mpi4py.mpi_c cimport *

#cimport mpi4py.MPI as MPI
#from mpi4py.mpi_c cimport *

cdef inline int CHKERR(int ierr):
    if ierr != MURGE_SUCCESS:
        raise MURGEError("error code %s" % ierr)     


# ...
global _nmatrices
_nmatrices = 0
# ...

# .................................
cdef extern from "mpi.h": pass
# .................................

# .................................
include "MURGE.pxd"
include "MURGE.pxi"
# .................................

# .................................
include "MURGE.pyx"
include "Matrix.pyx"
# .................................

