/* Copyright 2008 BORDEAUX I UNIVERSITY & INRIA 
**
** This file is part of the PaStiX parallel sparse matrix package.
**
** This software is governed by the CeCILL-C license under French law
** and abiding by the rules of distribution of free software. You can
** use, modify and/or redistribute the software under the terms of the
** CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
** URL: "http://www.cecill.info".
** 
** As a counterpart to the access to the source code and rights to copy,
** modify and redistribute granted by the license, users are provided
** only with a limited warranty and the software's author, the holder of
** the economic rights, and the successive licensors have only limited
** liability.
** 
** In this respect, the user's attention is drawn to the risks associated
** with loading, using, modifying and/or developing or reproducing the
** software by the user in light of its specific status of free software,
** that may mean that it is complicated to manipulate, and that also
** therefore means that it is reserved for developers and experienced
** professionals having in-depth computer knowledge. Users are therefore
** encouraged to load and test the software's suitability as regards
** their requirements in conditions enabling the security of their
** systems and/or data to be ensured and, more generally, to use and
** operate it in the same conditions as regards security.
** 
** The fact that you are presently reading this means that you have had
** knowledge of the CeCILL-C license and that you accept its terms.
*/
/**
 *
 *  PaStiX is a software package provided by Inria Bordeaux - Sud-Ouest,
 *  LaBRI, University of Bordeaux 1 and IPB.
 *
 * @version 5.2.0
 * @author Mathieu Faverge
 * @author Pierre Ramet
 * @author Xavier Lacoste
 * @date 2011-11-11
 * @precisions normal z -> c d s
 *
 **/
#ifndef Z_STARPU_ZSUBMIT_TASKS_H
#define Z_STARPU_ZSUBMIT_TASKS_H

#define pastix_int_t PASTIX_INT
#define z_Sopalin_Data_t Sopalin_Data_t
#define z_SolverCblk SolverCblk
#define z_SolverBlok SolverBlok
#define z_cblk_islocal cblk_islocal
#define z_fcblk_getnum fcblk_getnum
#define z_cblk_isfanin cblk_isfanin
#define z_cblk_ishalo cblk_ishalo
#define z_cblk_islocal cblk_islocal
#define z_is_block_inside_fblock is_block_inside_fblock
#define z_sopalin_clean_smp sopalin_clean_smp
#define z_sopalin_init_smp sopalin_init_smp
#define z_sopalin_clean sopalin_clean
#define PASTIX_MPI_INT COMM_INT
#define z_SolverMatrix SolverMatrix
#define z_CscMatrix CscMatrix
#define z_Thread_Data_t Thread_Data_t
#define z_hcblk_getnum hcblk_getnum
#define z_cblk_getnum cblk_getnum
#define starpu_zloop_data_  API_CALL(starpu_loop_data_)
#define starpu_zloop_data_t API_CALL(starpu_loop_data_t)
#define starpu_loop_data_  API_CALL(starpu_loop_data_)
#define starpu_loop_data_t API_CALL(starpu_loop_data_t)
typedef struct starpu_zloop_data_ starpu_zloop_data_t;

#define starpu_zsubmit_one_trf API_CALL(starpu_submit_one_trf)
int starpu_zsubmit_one_trf (pastix_int_t itertask, z_Sopalin_Data_t * sopalin_data);
#define starpu_zsubmit_bunch_of_gemm API_CALL(starpu_submit_bunch_of_gemm)
int starpu_zsubmit_bunch_of_gemm (pastix_int_t itertask, z_Sopalin_Data_t * sopalin_data);

#define starpu_zsubmit_tasks API_CALL(starpu_submit_tasks)
#define starpu_submit_tasks API_CALL(starpu_submit_tasks)
int starpu_zsubmit_tasks(z_Sopalin_Data_t   * sopalin_data);

#endif /* Z_STARPU_ZSUBMIT_TASKS_H */
